diff --git a/src/detection-plugins/sp_sctp_chunk_type.c b/src/detection-plugins/sp_sctp_chunk_type.c
new file mode 100644
index 0000000..ad3b4bc
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_type.c
@@ -0,0 +1,469 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <sys/types.h>
+#include <stdlib.h>
+#include <ctype.h>
+
+#include "sf_types.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "decode.h"
+#include "plugbase.h"
+#include "parser.h"
+#include "util.h"
+#include "snort_debug.h"
+#include "plugin_enum.h"
+#include "sp_sctp_chunk_type.h"
+
+#include "snort.h"
+#include "profiler.h"
+#ifdef PERF_PROFILING
+PreprocStats sctpChunkTypePerfStats;
+extern PreprocStats ruleOTNEvalPerfStats;
+#endif
+
+#include "sfhashfcn.h"
+#include "detection_options.h"
+
+
+/**
+ * SctpChunkTypeHash - Hash function for sctp_chunk_type.
+ * @data: pointer to SctpChunkFlagsData.
+ *
+ * Returns a uint32_t representing the hash.
+ */
+uint32_t SctpChunkTypeHash(void *data)
+{
+    uint32_t a, b, c;
+    SctpChunkTypeData *sctd = (SctpChunkTypeData *)data;
+
+    a = sctd->data;
+    b = sctd->init;
+    c = sctd->init_ack;
+    mix(a, b, c);
+    a += sctd->sack;
+    b += sctd->heartbeat;
+    c += sctd->heartbeat_ack;
+    mix(a, b, c);
+    a += sctd->abort;
+    b += sctd->shutdown;
+    c += sctd->shutdown_ack;
+    mix(a, b, c);
+    a += sctd->error;
+    b += sctd->cookie_echo;
+    c += sctd->cookie_ack;
+    mix(a, b, c);
+    a += sctd->ecne;
+    b += sctd->cwr;
+    c += sctd->shutdown_complete;
+    mix(a, b, c);
+    a += sctd->auth;
+    b += sctd->asconf_ack;
+    c += sctd->pktdrop;
+    mix(a, b, c);
+    a += sctd->pad;
+    b += sctd->forward_tsn;
+    c += sctd->asconf;
+    mix(a, b, c);
+    a += RULE_OPTION_TYPE_SCTP_CHUNK_TYPE;
+    final(a, b, c);
+
+    return c;
+}
+
+/**
+ * SctpChunkTypeCompare - Comparator function for sctp_chunk_type.
+ * @l: pointer to SctpChunkTypeData (left side).
+ * @r: pointer to SctpChunkTypeData (right side).
+ *
+ * Returns the comparison result of the two data structures.
+ */
+int SctpChunkTypeCompare(void *l, void *r)
+{
+    SctpChunkTypeData *left = (SctpChunkTypeData *)l;
+    SctpChunkTypeData *right = (SctpChunkTypeData *)r;
+
+    if (!left)
+        return (!right ? DETECTION_OPTION_EQUAL : 
+                         DETECTION_OPTION_NOT_EQUAL);
+    
+    if (!right)
+        return (!left ? DETECTION_OPTION_EQUAL : 
+                        DETECTION_OPTION_NOT_EQUAL);
+
+    if (left->data != right->data)                           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->init != right->init)                           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->init_ack != right->init_ack)                   return DETECTION_OPTION_NOT_EQUAL;
+    if (left->sack != right->sack)                           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->heartbeat != right->heartbeat)                 return DETECTION_OPTION_NOT_EQUAL;
+    if (left->heartbeat_ack != right->heartbeat_ack)         return DETECTION_OPTION_NOT_EQUAL;
+    if (left->abort != right->abort)                         return DETECTION_OPTION_NOT_EQUAL;
+    if (left->shutdown != right->shutdown)                   return DETECTION_OPTION_NOT_EQUAL;
+    if (left->shutdown_ack != right->shutdown_ack)           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->error != right->error)                         return DETECTION_OPTION_NOT_EQUAL;
+    if (left->cookie_echo != right->cookie_echo)             return DETECTION_OPTION_NOT_EQUAL;
+    if (left->cookie_ack != right->cookie_ack)               return DETECTION_OPTION_NOT_EQUAL;
+    if (left->ecne != right->ecne)                           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->cwr != right->cwr)                             return DETECTION_OPTION_NOT_EQUAL;
+    if (left->shutdown_complete != right->shutdown_complete) return DETECTION_OPTION_NOT_EQUAL;
+    if (left->auth != right->auth)                           return DETECTION_OPTION_NOT_EQUAL;
+    if (left->asconf_ack != right->asconf_ack)               return DETECTION_OPTION_NOT_EQUAL;
+    if (left->pktdrop != right->pktdrop)                     return DETECTION_OPTION_NOT_EQUAL;
+    if (left->pad != right->pad)                             return DETECTION_OPTION_NOT_EQUAL;
+    if (left->forward_tsn != right->forward_tsn)             return DETECTION_OPTION_NOT_EQUAL;
+    if (left->asconf != right->asconf)                       return DETECTION_OPTION_NOT_EQUAL;
+
+    return DETECTION_OPTION_EQUAL;
+}
+
+/**
+ * SctpChunkTypeSetup - Setup function for sctp_chunk_type.
+ *
+ * Links the 'sctp_chunk_type' keyword to its initialization function.
+ * Returns void.
+ */
+void SctpChunkTypeSetup(void)
+{
+    /* Map the keyword to an initialization/processing function */
+    RegisterRuleOption("sctp_chunk_type", SctpChunkTypeInit, NULL, OPT_TYPE_DETECTION, NULL);
+    
+#ifdef PERF_PROFILING
+    RegisterPreprocessorProfile("sctp_chunk_type", &sctpChunkTypePerfStats, 3, &ruleOTNEvalPerfStats);
+#endif
+
+    DEBUG_WRAP(DebugMessage(DEBUG_PLUGIN,"Plugin: SctpChunkType Initialized\n"););
+}
+
+/**
+ * SctpChunkTypeInit - Initialization function for sctp_chunk_type.
+ * @data: pointer to SctpChunkTypeData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ * @protocol: integer value representing the transport-layer protocol.
+ *
+ * Attaches the rule option data to the appropriate data structure and links
+ * in the evaluator function to the function pointer list.  Returns void.
+ */
+void SctpChunkTypeInit(char *data, OptTreeNode *otn, int protocol)
+{
+    OptFpList *fpl;
+    SctpChunkTypeData *sctd;
+    void *sctd_dup;
+
+    /* This keyword only applies to the SCTP Protocol. */
+    if (protocol != IPPROTO_SCTP)
+        FatalError("Error at %s:%d: 'sctp_chunk_types' can only be used with "
+                   "the SCTP protocol.\n", file_name, file_line);
+
+    /* Check for multiple uses of this keyword in a rule. */
+    if (otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE])
+        FatalError("%s(%d): 'sctp_chunk_type' may only be used once per "
+                   "rule.\n", file_name, file_line);
+
+    /* Allocate the data structure and attach it to the otn->ds_list. */
+    otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE] = (SctpChunkTypeData *)
+            SnortAlloc(sizeof(SctpChunkTypeData));
+
+    /* Parse the keyword's parameters and configure the data structure. */
+    SctpChunkTypeParse(data, otn);
+    sctd = otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE];
+
+    /* Check for a duplicate entry in the otn. */
+    if (add_detection_option(RULE_OPTION_TYPE_SCTP_CHUNK_TYPE,
+                             (void *)sctd, &sctd_dup) == DETECTION_OPTION_EQUAL)
+    {
+        otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE] = (SctpChunkTypeData *)sctd_dup;
+        free(sctd);
+    }
+
+    /*
+     * Finally, attach the option's detection function to the rule's detection
+     * function pointer list
+     */
+    fpl = AddOptFuncToList(SctpChunkTypeEval, otn);
+    fpl->type = RULE_OPTION_TYPE_SCTP_CHUNK_TYPE;
+    fpl->context = otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE];
+}
+
+/**
+ * SctpChunkTypeParse - Parsing function for sctp_chunk_type.
+ * @data: char pointer to SctpChunkTypeData.
+ * @otn: pointer to the OptTreeNode structure.
+ *
+ * Parses the rule option's parameter list and fills in the SctpChunkTypeData
+ * structure.  Returns void.
+ */
+void SctpChunkTypeParse(char *data, OptTreeNode *otn)
+{
+    char *tok, *params;
+    SctpChunkTypeData *sctd;
+
+    /* Set the sctd pointer to make it easier to reference the option's
+       particular data struct */
+    sctd = otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE];
+
+    params = SnortStrdup(data);
+    while(isspace((int)*params)) params++;     /* nuke leading whitespace */
+    
+    /* Make sure at least one value was supplied. */
+    tok = strtok(params, ",");
+    if (!tok)
+        FatalError("Error at %s:%d: Missing argument to the 'sctp_chunk_type' "
+                   "keyword\n", file_name, file_line);
+
+    /* Negation - Only handled on the first token. */
+    if (tok[0] == '!')
+    {
+        sctd->neg = 1;
+        tok++;
+    }
+
+    /* Parse each token. */
+    while (tok)
+    {
+        /* Limit the number of tokens to be (SCTP_MAX_NUM_CHUNKS - 1). */
+        if (sctd->parse_count >= SCTP_MAX_NUM_CHUNKS)
+            FatalError("Error at %s:%d: Number of parameters exceeds "
+                       "SCTP_MAX_NUM_CHUNKS (%d)!\n", file_name,
+                       file_line, SCTP_MAX_NUM_CHUNKS);
+
+        /*
+         * For each token, See what the specified chunk type is and set its
+         * appropriate member in the sctd structure to be 'true'.
+         */
+        if      (!strcasecmp("DATA", tok))              sctd->data = 1;
+        else if (!strcasecmp("INIT", tok))              sctd->init = 1;
+        else if (!strcasecmp("INIT-ACK", tok))          sctd->init_ack = 1;
+        else if (!strcasecmp("SACK", tok))              sctd->sack = 1;
+        else if (!strcasecmp("HEARTBEAT", tok))         sctd->heartbeat = 1;
+        else if (!strcasecmp("HEARTBEAT-ACK", tok))     sctd->heartbeat_ack = 1;
+        else if (!strcasecmp("ABORT", tok))             sctd->abort = 1;
+        else if (!strcasecmp("SHUTDOWN", tok))          sctd->shutdown = 1;
+        else if (!strcasecmp("SHUTDOWN-ACK", tok))      sctd->shutdown_ack = 1;
+        else if (!strcasecmp("ERROR", tok))             sctd->error = 1;
+        else if (!strcasecmp("COOKIE-ECHO", tok))       sctd->cookie_echo = 1;
+        else if (!strcasecmp("COOKIE-ACK", tok))        sctd->cookie_ack = 1;
+        else if (!strcasecmp("ECNE", tok))              sctd->ecne = 1;
+        else if (!strcasecmp("CWR", tok))               sctd->cwr = 1;
+        else if (!strcasecmp("SHUTDOWN-COMPLETE", tok)) sctd->shutdown_complete = 1;
+        else if (!strcasecmp("AUTH", tok))              sctd->auth = 1;
+        else if (!strcasecmp("ASCONF-ACK", tok))        sctd->asconf_ack = 1;
+        else if (!strcasecmp("PKTDROP", tok))           sctd->pktdrop = 1;
+        else if (!strcasecmp("PAD", tok))               sctd->pad = 1;
+        else if (!strcasecmp("FORWARD-TSN", tok))       sctd->forward_tsn = 1;
+        else if (!strcasecmp("ASCONF", tok))            sctd->asconf = 1;
+        else
+            FatalError("Error at %s:%d: %s is not a recognized argument to "
+                       "'sctp_chunk_type'.\n", file_name, file_line, tok);
+
+        sctd->parse_count++;
+        tok = strtok(NULL, ",");
+    }
+}
+
+
+/**
+ * SctpChunkTypeEval - Evaluation function for sctp_chunk_type.
+ * @data: void pointer to SctpChunkTypeData.
+ * @p: pointer to the Packet structure.
+ *
+ * Evaluates the rule option against the packet pointed to by 'p'.  Returns
+ * either DETECTION_OPTION_MATCH or DETECTION_OPTION_NO_MATCH.
+ */
+int SctpChunkTypeEval(void *data, Packet *p)
+{
+    SctpChunkTypeData *sctd = (SctpChunkTypeData *)data;
+    int rval;
+    PROFILE_VARS;
+
+    if(!p->sctph || !sctd)
+        return DETECTION_OPTION_NO_MATCH;
+
+    PREPROC_PROFILE_START(sctpChunkTypePerfStats);
+
+    SctpChunk *c = (SctpChunk *)p->sctph->chunks;
+    uint32_t remaining_len = p->dsize;
+
+    /*
+     * Pre-assignment for rval.  Yes, it's inverted.  Don't try to think
+     * about it, because you'll only wind up getting hurt.  There is probably
+     * a better way to do this.
+     */
+    rval = (sctd->neg ? DETECTION_OPTION_MATCH :
+                        DETECTION_OPTION_NO_MATCH);
+
+    /*
+     * For each chunk, look at its type field and find the corresponding
+     * member in the SctpChunkTypeData struct.  If it is true, then see
+     * whether we have to deal with negation.
+     */
+    while ((c != NULL) && (remaining_len != 0))
+    {
+        uint16_t chunk_length = SCTP_ADD_PADDING(ntohs(c->length));
+        remaining_len -= chunk_length;
+        
+        switch (c->type)
+        {
+            case SCTP_DATA_C:
+                if (sctd->data)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_INIT_C:
+                if (sctd->init)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_INIT_ACK_C:
+                if (sctd->init_ack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_SACK_C:
+                if (sctd->sack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_HEARTBEAT_C:
+                if (sctd->heartbeat)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_HEARTBEAT_ACK_C:
+                if (sctd->heartbeat_ack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_ABORT_C:
+                if (sctd->abort)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_SHUTDOWN_C:
+                if (sctd->shutdown)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_SHUTDOWN_ACK_C:
+                if (sctd->shutdown_ack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_ERROR_C:
+                if (sctd->error)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_COOKIE_ECHO_C:
+                if (sctd->cookie_echo)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_COOKIE_ACK_C:
+                if (sctd->cookie_ack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_ECNE_C:
+                if (sctd->ecne)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_CWR_C:
+                if (sctd->cwr)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_SHUTDOWN_COMPLETE_C:
+                if (sctd->shutdown_complete)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_AUTH_C:
+                if (sctd->auth)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_ASCONF_ACK_C:
+                if (sctd->asconf_ack)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_PKTDROP_C:
+                if (sctd->pktdrop)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_PAD_C:
+                if (sctd->pad)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_FORWARD_TSN_C:
+                if (sctd->forward_tsn)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            case SCTP_ASCONF_C:
+                if (sctd->asconf)
+                    rval = (sctd->neg ? DETECTION_OPTION_NO_MATCH :
+                                        DETECTION_OPTION_MATCH);
+                break;
+
+            default:
+                DEBUG_WRAP(DebugMessage(
+                    DEBUG_PLUGIN, "Plugin (sctp_chunk_type): Encountered "
+                                  "unknown SCTP Chunk Type 0x%2x!\n",
+                                  c->type));
+                break;
+        }
+
+        remaining_len = SctpGetNextChunk(c, remaining_len, chunk_length);
+    }
+
+    /* If the test isn't successful, return DETECTION_OPTION_NO_MATCH */
+    PREPROC_PROFILE_END(sctpChunkTypePerfStats);
+    return rval;
+}
diff --git a/src/detection-plugins/sp_sctp_chunk_type.h b/src/detection-plugins/sp_sctp_chunk_type.h
new file mode 100644
index 0000000..6c93fa6
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_type.h
@@ -0,0 +1,63 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+#ifndef __SP_SCTP_CHUNK_TYPE_H__
+#define __SP_SCTP_CHUNK_TYPE_H__
+
+/* Current number of chunks, defined by approved RFC's */
+#define SCTP_MAX_NUM_CHUNKS         21
+
+/* SctpChunkType data structure. */
+typedef struct _SctpChunkTypeData
+{
+    uint8_t parse_count;
+    uint8_t neg;
+    uint8_t data;
+    uint8_t init;
+    uint8_t init_ack;
+    uint8_t sack;
+    uint8_t heartbeat;
+    uint8_t heartbeat_ack;
+    uint8_t abort;
+    uint8_t shutdown;
+    uint8_t shutdown_ack;
+    uint8_t error;
+    uint8_t cookie_echo;
+    uint8_t cookie_ack;
+    uint8_t ecne;
+    uint8_t cwr;
+    uint8_t shutdown_complete;
+    uint8_t auth;
+    uint8_t asconf_ack;
+    uint8_t pktdrop;
+    uint8_t pad;
+    uint8_t forward_tsn;
+    uint8_t asconf;
+} SctpChunkTypeData;
+
+/* Prototypes. */
+uint32_t SctpChunkTypeHash(void *data);
+int SctpChunkTypeCompare(void *l, void *r);
+void SctpChunkTypeSetup(void);
+void SctpChunkTypeInit(char *data, OptTreeNode *otn, int protocol);
+void SctpChunkTypeParse(char *data, OptTreeNode *otn);
+int SctpChunkTypeEval(void *data, Packet *p);
+
+#endif  /* __SP_SCTP_CHUNK_TYPE_H__ */
diff --git a/src/detection-plugins/sp_sctp_num_chunks.c b/src/detection-plugins/sp_sctp_num_chunks.c
new file mode 100644
index 0000000..69d8ef5
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_num_chunks.c
@@ -0,0 +1,281 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <sys/types.h>
+#include <stdlib.h>
+#include <ctype.h>
+
+#include "sf_types.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "decode.h"
+#include "plugbase.h"
+#include "parser.h"
+#include "util.h"
+#include "snort_debug.h"
+#include "plugin_enum.h"
+#include "sp_sctp_num_chunks.h"
+
+#include "snort.h"
+#include "profiler.h"
+#ifdef PERF_PROFILING
+PreprocStats sctpNumChunksPerfStats;
+extern PreprocStats ruleOTNEvalPerfStats;
+#endif
+
+#include "sfhashfcn.h"
+#include "detection_options.h"
+
+
+/**
+ * SctpNumChunksHash - Hash function for sctp_num_chunks.
+ * @data: pointer to SctpNumChunksData.
+ *
+ * Returns a uint32_t representing the hash.
+ */
+uint32_t SctpNumChunksHash(void *data)
+{
+    uint32_t a, b, c;
+    SctpNumChunksData *sncd = (SctpNumChunksData *)data;
+
+    a = sncd->num_chunks_min;
+    b = sncd->num_chunks_max;
+    c = (uint32_t)sncd->operator;
+    mix(a, b, c);
+
+    a += RULE_OPTION_TYPE_SCTP_NUM_CHUNKS;
+    final(a, b, c);
+
+    return c;
+}
+
+/**
+ * SctpNumChunksCompare - Comparator function for sctp_num_chunks.
+ * @l: pointer to SctpNumChunksData (left side).
+ * @r: pointer to SctpNumChunksData (right side).
+ *
+ * Returns the comparison result of the two data structures.
+ */
+int SctpNumChunksCompare(void *l, void *r)
+{
+    SctpNumChunksData *left = (SctpNumChunksData *)l;
+    SctpNumChunksData *right = (SctpNumChunksData *)r;
+
+    if (!left)
+        return (!right ? DETECTION_OPTION_EQUAL : 
+                         DETECTION_OPTION_NOT_EQUAL);
+    
+    if (!right)
+        return (!left ? DETECTION_OPTION_EQUAL : 
+                        DETECTION_OPTION_NOT_EQUAL);
+
+    if (left->operator != right->operator)             return DETECTION_OPTION_NOT_EQUAL;
+    if (left->num_chunks_min != right->num_chunks_min) return DETECTION_OPTION_NOT_EQUAL;
+    if (left->num_chunks_max != right->num_chunks_max) return DETECTION_OPTION_NOT_EQUAL;
+
+    return DETECTION_OPTION_EQUAL;
+}
+
+/**
+ * SctpNumChunksSetup - Setup function for sctp_num_chunks.
+ *
+ * Links the 'sctp_num_chunks' keyword to its initialization function.
+ * Returns void.
+ */
+void SctpNumChunksSetup(void)
+{
+    /* Map the keyword to an initialization/processing function */
+    RegisterRuleOption("sctp_num_chunks", SctpNumChunksInit, NULL, OPT_TYPE_DETECTION, NULL);
+    
+#ifdef PERF_PROFILING
+    RegisterPreprocessorProfile("sctp_num_chunks", &sctpNumChunksPerfStats, 3, &ruleOTNEvalPerfStats);
+#endif
+
+    DEBUG_WRAP(DebugMessage(DEBUG_PLUGIN,"Plugin: SctpNumChunks Initialized\n"););
+}
+
+/**
+ * SctpNumChunksInit - Initialization function for sctp_num_chunks.
+ * @data: pointer to SctpNumChunksData.
+ * @otn: pointer to OptTreeNode structure.
+ * @protocol: integer value representing the transport-layer protocol.
+ *
+ * Attaches the rule option data to the appropriate data structure and links
+ * in the evaluator function to the function pointer list.  Returns void.
+ */
+void SctpNumChunksInit(char *data, OptTreeNode *otn, int protocol)
+{
+    OptFpList *fpl;
+    SctpNumChunksData *sncd;
+    void *sncd_dup;
+
+    /* This keyword only applies to the SCTP Protocol. */
+    if (protocol != IPPROTO_SCTP)
+        FatalError("Error at %s:%d: 'sctp_num_chunks' can only be used with "
+                   "the SCTP protocol.\n", file_name, file_line);
+
+    /* Check for multiple uses of this keyword in a rule. */
+    if (otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS])
+        FatalError("Error at %s:%d: 'sctp_num_chunks' may only be used once per "
+                   "rule.\n", file_name, file_line);
+
+    /* Allocate the data structure and attach it to the otn->ds_list. */
+    otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS] = (SctpNumChunksData *)
+            SnortAlloc(sizeof(SctpNumChunksData));
+
+    /* Parse the keyword's parameters and configure the data structure. */
+    SctpNumChunksParse(data, otn);
+    sncd = otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS];
+
+    /* Check for a duplicate entry in the otn. */
+    if (add_detection_option(RULE_OPTION_TYPE_SCTP_NUM_CHUNKS,
+                             (void *)sncd, &sncd_dup) == DETECTION_OPTION_EQUAL)
+    {
+        otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS] = (SctpNumChunksData *)sncd_dup;
+        free(sncd);
+    }
+
+    /*
+     * Finally, attach the option's detection function to the rule's detection
+     * function pointer list
+     */
+    fpl = AddOptFuncToList(SctpNumChunksEval, otn);
+    fpl->type = RULE_OPTION_TYPE_SCTP_NUM_CHUNKS;
+    fpl->context = (void *)otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS];
+}
+
+/**
+ * SctpNumChunksParse - Parsing function for sctp_num_chunks.
+ * @data: pointer to SctpNumChunksData.
+ * @otn: pointer to OptTreeNode structure.
+ *
+ * Parses the rule option's parameter list and fills in the SctpNumChunksData
+ * structure.  Returns void.
+ */
+void SctpNumChunksParse(char *data, OptTreeNode *otn)
+{
+    char *tok = data, *end;
+    int num = 0, rval = 0;
+    UNumericRange rng;
+    SctpNumChunksData *sncd;
+
+    /* Get the sctp_num_chunks data set. */
+    sncd = otn->ds_list[PLUGIN_SCTP_NUM_CHUNKS];
+
+    while(isspace((int)*tok)) tok++;
+
+    /* Parse out the operands of the range. */
+    rval = SnortStrToUNumRng(tok, "<>", &rng);
+    if (rval == SNORT_STR2RNG_SUCCESS)
+    {
+        sncd->num_chunks_min = rng.min;
+        sncd->num_chunks_max = rng.max;
+        sncd->operator = SCTP_NUM_CHUNKS_RANGE;
+    }
+
+    /* Not a ranged value. */
+    else if (rval == SNORT_STR2RNG_NOTRNG)
+    {
+        if (*tok == '>')
+        {
+            tok++;
+            sncd->operator = SCTP_NUM_CHUNKS_GT;
+        }
+        else if(*tok == '<')
+        {
+            tok++;
+            sncd->operator = SCTP_NUM_CHUNKS_LT;
+        }
+        else
+            sncd->operator = SCTP_NUM_CHUNKS_EQUAL;
+    }
+
+    /* Error. */
+    else if (rval == SNORT_STR2RNG_ERROR)
+        goto error;
+
+    /* Parse the remainder and store it as the minimum value. */
+    num = strtol(tok, &end, 10);
+    if (*end)
+        goto error;
+
+    sncd->num_chunks_min = num;
+
+    return;
+
+error:
+    FatalError("Error at %s:%d: Invalid 'sctp_num_chunks' argument.\n",
+               file_name, file_line);
+    return;
+}
+
+/**
+ * SctpNumChunksEval - Evaluation function for sctp_num_chunks.
+ * @data: pointer to SctpNumChunksData (as char *).
+ * @p: pointer to Packet structure.
+ *
+ * Evaluates the rule option against the packet pointed to by 'p'.  Returns
+ * either DETECTION_OPTION_MATCH or DETECTION_OPTION_NO_MATCH.
+ */
+int SctpNumChunksEval(void *data, Packet *p)
+{
+    SctpNumChunksData *sncd = (SctpNumChunksData *)data;
+    int rval = DETECTION_OPTION_NO_MATCH;
+    PROFILE_VARS;
+
+    if(!p->sctph || !sncd)
+        return rval;
+
+    PREPROC_PROFILE_START(sctpNumChunksPerfStats);
+
+    /* The chunk count is maintained in Packet *p. */
+    switch (sncd->operator)
+    {
+        case SCTP_NUM_CHUNKS_EQUAL:
+            if (sncd->num_chunks_min == p->sctp_chunk_count)
+                rval = DETECTION_OPTION_MATCH;
+            break;
+
+        case SCTP_NUM_CHUNKS_GT:
+            if (sncd->num_chunks_min < p->sctp_chunk_count)
+                rval = DETECTION_OPTION_MATCH;
+            break;
+
+        case SCTP_NUM_CHUNKS_LT:
+            if (sncd->num_chunks_min > p->sctp_chunk_count)
+                rval = DETECTION_OPTION_MATCH;
+            break;
+
+        case SCTP_NUM_CHUNKS_RANGE:
+            if ((sncd->num_chunks_min <= p->sctp_chunk_count) &&
+                (sncd->num_chunks_max >= p->sctp_chunk_count))
+                rval = DETECTION_OPTION_MATCH;
+            break;
+    }
+
+    /* If the test isn't successful, return DETECTION_OPTION_NO_MATCH */
+    PREPROC_PROFILE_END(sctpNumChunksPerfStats);
+    return rval;
+}
diff --git a/src/detection-plugins/sp_sctp_num_chunks.h b/src/detection-plugins/sp_sctp_num_chunks.h
new file mode 100644
index 0000000..b3ff016
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_num_chunks.h
@@ -0,0 +1,46 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+#ifndef __SP_SCTP_NUM_CHUNKS_H__
+#define __SP_SCTP_NUM_CHUNKS_H__
+
+/* Operator definitions for sctp_payload_id. */
+#define SCTP_NUM_CHUNKS_EQUAL               0x01
+#define SCTP_NUM_CHUNKS_LT                  0x02
+#define SCTP_NUM_CHUNKS_GT                  0x03
+#define SCTP_NUM_CHUNKS_RANGE               0x04
+
+/* SctpPayloadId data structure. */
+typedef struct _SctpNumChunksData
+{
+    uint32_t num_chunks_min;
+    uint32_t num_chunks_max;
+    uint8_t operator;
+} SctpNumChunksData;
+
+/* Prototypes. */
+uint32_t SctpNumChunksHash(void *data);
+int SctpNumChunksCompare(void *l, void *r);
+void SctpNumChunksSetup(void);
+void SctpNumChunksInit(char *data, OptTreeNode *otn, int protocol);
+void SctpNumChunksParse(char *data, OptTreeNode *otn);
+int SctpNumChunksEval(void *data, Packet *p);
+
+#endif  /* __SP_SCTP_NUM_CHUNKS_H__ */
